<img src="https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/banner.png?raw=true" width=100%/>

# Inshorts clone (The News App)

The Clone of the populer News App in India

[<img src="https://s18955.pcdn.co/wp-content/uploads/2018/02/github.png" width="25"/>](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App) [fork on Github](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App)

**_Try latest inshorts Clone app apk from below 👇_**

[inshortsClone.apk](https://drive.google.com/file/d/1D0U3uX1GGse8BMWsQ-NIGgEIPkOJNL0a/view?usp=sharing)

[![GitHub license](https://img.shields.io/github/license/Naereen/StrapDown.js.svg)](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/LICENSE)

<!--
[![Github all releases](https://img.shields.io/github/downloads/Naereen/StrapDown.js/total.svg)](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/releases/)
-->

### Update

#### Multiple Language Support

|                                                    English                                                    |                                                    हिंदी                                                    |                                                     मराठी                                                     |                                                     ಕನ್ನಡ                                                     |
| :-----------------------------------------------------------------------------------------------------------: | :---------------------------------------------------------------------------------------------------------: | :-----------------------------------------------------------------------------------------------------------: | :-----------------------------------------------------------------------------------------------------------: |
| ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/english.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/hindi.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/marathi.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/kannada.png?raw=true) |

### Instruction

Replace the API Key field with your own key, for key visit [newsapi.org](https://themoviedb.org) and create your id.

```
  |-- lib
  |  |-- global
  |      |-- global.dart

```

```dart
    final String apikey = "YOUR_KEY";
```

## Features

- Dark Mode
- Multi Language Support [ English, हिंदी, मराठी, ಕನ್ನಡ ]
- Share News Card As Image
- Offline Read
- Watermark on shared news card
- Webview

### ScreenShots

|                                                    Dscover                                                     |                                                    Feed                                                    |                                                    Settings                                                    |                                                Language Support                                                |
| :------------------------------------------------------------------------------------------------------------: | :--------------------------------------------------------------------------------------------------------: | :------------------------------------------------------------------------------------------------------------: | :------------------------------------------------------------------------------------------------------------: |
| ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/discover.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/feed.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/settings.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/language.png?raw=true) |

|                                                    Search                                                    |                                                   Dark Mode                                                    |                                                    Dark Mode                                                    |                                                    Watermark                                                    |
| :----------------------------------------------------------------------------------------------------------: | :------------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------------: |
| ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/search.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/darkmode.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/darkmode1.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/watermark.png?raw=true) |

|                                                    Bookmark                                                     |                                                    Loading                                                    |                                                Web Screen                                                 |                                                    Share                                                    |
| :-------------------------------------------------------------------------------------------------------------: | :-----------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------: | :---------------------------------------------------------------------------------------------------------: |
| ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/bookmarks.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/loading.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/web.png?raw=true) | ![](https://github.com/imSanjaySoni/Inshorts-Clone-The-News-App/blob/master/screenshots/share.png?raw=true) |

## Packages Used

- flutter_bloc & Dio : for http Request Handling.
- Provider : for State Management.
- Hive : for Local Strorage Management.
- esys_flutter_share : for Sharing News card.
- webview_flutter : web view inside the app.
- auto_route : Page Routing.
- photo_view : gives extra features like image scaling.

### License

```
MIT License

Copyright (c) 2020 Sanjay Soni

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

```
